## Helper functions for FPPassFail


Parentals_passfail <- function(line,Parentals,PD,CCLElines){
  
  
  
  line_clean <- removeSpecialCharacters(line)
  
  # Get information from this line
  lineCCLEinfo <- Parentals[which(Parentals$FPCellLine %in% line), ]
  linePDinfo <- PD[which(PD$Input_line %in% line), ]
  
  # Could this ever be in CCLE?
  if(length(grep(line_clean,CCLElines)) != 0){
    CCLEexist <- 1
  } else {
    CCLEexist <- 0
  }
  
  
  if(lineCCLEinfo$identity <= 0.7){
    
    if(CCLEexist == 0){
      passfail <- "Not previously seen"
      reason <- " "
    } else {
      passfail <- "Fail"
      reason <- "Did not match itself in CCLE"
    }
    
  } else if(lineCCLEinfo$identity > 0.7 & lineCCLEinfo$identity < 0.8 & lineCCLEinfo$KnownMatch.CCLE == "Y"){
    
    if(CCLEexist ==0){
      passfail <- "Previously seen borderline"
      reason <- " CCLE similarity"
    } else {
      passfail <- "Borderline"
      reason <- "CCLE similarity"
    }
    
  } else if(lineCCLEinfo$KnownMatch.CCLE == "Y"){
    
    if(CCLEexist ==1){
    passfail <- "Pass"
    reason <- " "
    } else {
      passfail <- "Previously seen"
      reason <- "Matches something in CCLE"
    }
  } else if(lineCCLEinfo$FPmatch.CCLE == "Y" & lineCCLEinfo$KnownMatch.CCLE == "N"){
    
    passfail <- "Fail"
    reason <- "Matched the incorrect CCLE line."
    
  } else {
    
    if(CCLEexist == 0){
      passfail <- "Previously seen borderline"
      reason <- "Could not be called"
    } else {
      passfail <- "Borderline"
      reason <- "Could not be called"
    }
  }
  
  
  ## Now for check 2 of parentals
  
  if(passfail == "Pass"){
    
    # Should this match anything from the master?
    if(any(is.na(linePDinfo$FPmatch.itself))){
      # Then it should  never have matched, so it should not match
      if(any(linePDinfo$Similarity >= 0.8)){
        
        passfail <- "Fail"
        reason <- paste("Matched ",linePDinfo$Reference_line[1]," instead of itself. Similarity ",linePDinfo$Similarity[1], sep = "")
        
      } else if(min(linePDinfo$Similarity) > 0.7 & max(linePDinfo$Similarity < 0.8)){
        
        passfail <- "Borderline"
        reason <- paste("Possible matching to ",linePDinfo$Reference_line," with a similarity of",linePDinfo$Similarity[1], sep = "")
        
      } else {
        
        passfail <- "Borderline"
        reason <- "Could not be called"
        
      }
      
    } else if(all(linePDinfo$FPmatch.itself == "Y" & linePDinfo$Similarity >= 0.8)){
      
      passfail <- "Pass"
      reason <- " "
      
    } else {
      
      passfail <- "Borderline"
      reason <- "Could not be called"
      
    }
    
    
    
  }
  
  
  
  print(line)
  print(passfail)
  print(reason)
  
  outdf <- data.frame(line = line, passfail = passfail, reason = reason)
  return(outdf)
  
}






Derivatives_passfail <- function(line,Derivatives,PD,CCLElines){
  
    line_clean <- clean_names(line)
  
  # Get information from this line
  lineCCLEinfo <- Derivatives[which(Derivatives$FPCellLine %in% line), ]
  linePDinfo <- PD[which(PD$Input_line %in% line), ]
  
  # Could this ever be in CCLE?
  if(length(grep(line_clean,CCLElines)) != 0){
    CCLEexist <- 1
  } else {
    CCLEexist <- 0
  }
  
  linePDinfo$FPmatch.itself[is.na(linePDinfo$FPmatch.itself)] <- "non"
  
  if(linePDinfo$FPmatch.itself == "Y" & linePDinfo$Similarity >= 0.8){
    
    passfail <- "Pass"
    reason <- " "
    
  } else if(max(linePDinfo$Similarity) < 0.8 & min(linePDinfo$Similarity >0.7)){
    
    passfail <- "Borderline"
    reason <- paste("Possible match to ",linePDinfo$Reference_line[1],". Similarity ", linePDinfo$Similarity[1], sep = "")
    
  } else if(any(linePDinfo$FPmatch.itself == "N")){
    
    passfail <- "Fail"
    reason <- paste("Matches incorrectly to ",linePDinfo$Reference_line[1], sep = "")
    
  } else {
    
    passfail <- "Borderline"
    reason <- "Could not be called"
    
  }
  
  # If passes, go to check 2
  if(passfail == "Pass"){
    
    # Now working with lineCCLEinfo
    if(lineCCLEinfo$KnownMatch.CCLE == "Y" & lineCCLEinfo$identity > 0.8){
      
      passfail <- "Pass"
      reason <- " "
      
    } else if(max(lineCCLEinfo$identity) < 0.8 & min(lineCCLEinfo$identity >0.7)){
      
      passfail <- "Borderline"
      reason <- paste("Possible match to ",lineCCLEinfo$CleanCellLine.SNP6[1],". Similarity ", linePDinfo$Similarity[1], sep = "")
      
    } else if(lineCCLEinfo$identity < 0.7){
      if(CCLEexist == 1){
        passfail <- "Fail"
        reason <- paste("Does not match parental. Closest match ", lineCCLEinfo$CleanCellLine.SNP6[1], " with similarity ", lineCCLEinfo$identity[1], sep = "")
        
      } else {
        passfail <- "Pass"
        reason <- " "
      }
    } else if(lineCCLEinfo$identity > 0.8 & lineCCLEinfo$KnownMatch.CCLE == "N"){
      
      passfail <- "Fail"
      reason <- paste("Matches incorrectly to ",lineCCLEinfo$CleanCellLine.SNP6[1], sep = "")
    } else {
      
      passfail <- "Borderline"
      reason <- "Could not be called"
      
    }
    
    
  }
  
  
  
  
  
  outdf <- data.frame(line = line, passfail = passfail, reason = reason)
  return(outdf)
  

}










Screens_passfail <- function(line,Screens,RS,CCLElines){
  line_clean <- clean_names(line)
  
  # Get information from this line
  lineCCLEinfo <- Screens[which(Screens$FPCellLine %in% line), ]
  lineRSinfo <- RS[which(RS$Input_line %in% line), ]
  
  # Could this ever be in CCLE?
  if(length(grep(line_clean,CCLElines)) != 0){
    CCLEexist <- 1
  } else {
    CCLEexist <- 0
  }
  
  lineRSinfo$FPmatch.itself[is.na(lineRSinfo$FPmatch.itself)] <- "non"
  lineCCLEinfo$KnownMatch.CCLE[is.na(lineCCLEinfo$KnownMatch.CCLE)] <- "non"
  
  if(lineRSinfo$FPmatch.itself == "Y" & lineRSinfo$Similarity >= 0.8){
    
    passfail <- "Pass"
    reason <- " "
    
  } else if(max(lineRSinfo$Similarity) < 0.8 & min(lineRSinfo$Similarity >0.7)){
    
    passfail <- "Borderline"
    reason <- paste("Possible match to ",lineRSinfo$Reference_line[1],". Similarity ", lineRSinfo$Similarity[1], sep = "")
    
  } else if(any(lineRSinfo$FPmatch.itself == "N")){
    
    passfail <- "Fail"
    reason <- paste("Matches incorrectly to ",lineRSinfo$Reference_line[1], sep = "")
    
  } else {
    
    passfail <- "Borderline"
    reason <- "Could not be called"
    
  }
  
  # If passes, go to check 2
  if(passfail == "Pass"){
    
    # Now working with lineCCLEinfo
    if(lineCCLEinfo$KnownMatch.CCLE == "Y" & lineCCLEinfo$identity > 0.8){
      
      passfail <- "Pass"
      reason <- " "
      
    } else if(max(lineCCLEinfo$identity) < 0.8 & min(lineCCLEinfo$identity >0.7)){
      
      passfail <- "Borderline"
      reason <- paste("Possible match to ",lineCCLEinfo$CleanCellLine.SNP6[1],". Similarity ", lineCCLEinfo$identity[1], sep = "")
      
    } else if(lineCCLEinfo$identity < 0.7){
      
      if(CCLEexist == 1){
        
        passfail <- "Fail"
        reason <- paste("Does not match parental. Closest match ", lineCCLEinfo$CleanCellLine.SNP6[1], " with similarity ", lineCCLEinfo$identity[1], sep = "")
        
      } else {
        passfail <- "Pass"
        reason <- " "
      }
    } else if(lineCCLEinfo$identity > 0.8 & lineCCLEinfo$KnownMatch.CCLE == "N"){
      
      passfail <- "Fail"
      reason <- paste("Matches incorrectly to ",lineCCLEinfo$CleanCellLine.SNP6[1], sep = "")
    } else {
      
      passfail <- "Borderline"
      reason <- "Could not be called"
      
    }
    
    
  }
  
  
  
  
  
  outdf <- data.frame(line = line, passfail = passfail, reason = reason)
  
  
  
  
  
  return(outdf)
  
  
}



matchIdentity <- function(identity){
  
  if(identity < 0.7){
    mi <- "no"
  } else if(identity > 0.8){
    mi <- "yes"
  } else {
    mi <- "maybe"
  }
  
  return(mi)
}




derivative_ccle_passfail <- function(rowOfData){
  
  if(rowOfData$isLineInCCLE == "yes"){
    if(rowOfData$KnownMatch.CCLE == "Y" & rowOfData$matchIdentity == "yes"){
      passfail <- "Pass"
    } else if(rowOfData$matchIdentity == "maybe"){
      passfail <- "Borderline"
    } else {
      passfail <- "Fail"
    }
  } else {
    if(rowOfData$matchIdentity == "no"){
      passfail <- "Pass"
    } else if(rowOfData$matchIdentity == "maybe"){
      passfail <- "Borderline"
    } else {
      passfail <- "Fail"
    }
    
  }
  
  return(passfail)
}
  


parental_ccle_passfail <- function(rowOfData){
  
  
  if(rowOfData$isLineInCCLE == "yes"){
    if(rowOfData$KnownMatch.CCLE == "Y" & rowOfData$matchIdentity == "yes"){
      passfail <- "Pass"
    } else if(rowOfData$matchIdentity == "no"){
      passfail <- "Fail"
    } else {
      passfail <- "Borderline"
    }
  } else {
    # Then it could not match itself in CCLE and needs to not match anything else
    if(rowOfData$matchIdentity == "no"){
      passfail <- "Not Previously seen"
    } else if(rowOfData$matchIdentity == "yes"){
      passfail <- "Previously seen"
    } else {
      passfail <- "Previously seen borderline"
    }
    
  }
  
  return(passfail)
  
}






screen_ccle_passfail <- function(rowOfData){
  
  
  if(rowOfData$isLineInCCLE == "yes"){
    if(rowOfData$KnownMatch.CCLE == "Y" & rowOfData$matchIdentity == "yes"){
      passfail <- "Pass"
    } else if(rowOfData$matchIdentity == "no"){
      passfail <- "Fail"
    } else {
      passfail <- "Borderline"
    }
  } else {
    # Then it could not match itself in CCLE and needs to not match anything else
    if(rowOfData$matchIdentity == "no"){
      passfail <- "Pass"
    } else if(rowOfData$matchIdentity == "yes"){
      passfail <- "Fail"
    } else {
      passfail <- "Borderline"
    }
    
  }
  
  return(passfail)
  
}





derivative_m2m_passfail <- function(rowOfData){
  
  if(rowOfData$matchIdentity == "yes" & rowOfData$FPmatch.itself == "Y"){
    
    passfail <- "Pass"
    
  } else if(rowOfData$matchIdentity == "yes" & rowOfData$FPmatch.itself == "N"){
    
    passfail <- "Fail"
    
  } else {
    
    passfail <- "Borderline"
    
  }
  
}




screen_m2m_passfail <- function(rowOfData){
  
  if(rowOfData$matchIdentity == "yes" & rowOfData$FPmatch.itself == "Y"){
    
    passfail <- "Pass"
    
  } else if(rowOfData$matchIdentity == "yes" & rowOfData$FPmatch.itself == "N"){
    
    passfail <- "Fail"
    
  } else {
    
    passfail <- "Borderline"
    
  }
  
}




parental_m2m_passfail <- function(rowOfData){
  if(rowOfData$isLineInCCLE == "yes"){
    if(rowOfData$matchIdentity == "yes" & rowOfData$FPmatch.itself == "Y"){
      
      passfail <- "Pass"
      
    } else if(rowOfData$matchIdentity == "yes" & rowOfData$FPmatch.itself == "N"){
      
      passfail <- "Fail"
      
    } else {
      
      passfail <- "Borderline"
      
    }
    
  } else {
    
    if(rowOfData$matchIdentity == "yes" & rowOfData$FPmatch.itself == "Y"){
      
      passfail <- "Not Previously seen"
      
    } else if(rowOfData$matchIdentity == "yes" & rowOfData$FPmatch.itself == "N"){
      
      passfail <- "Previously seen"
      
    } else {
      
      passfail <- "Previously seen borderline"
      
    }
    
  }
}