## The Broad Institute
## SOFTWARE COPYRIGHT NOTICE AGREEMENT
## This software and its documentation are copyright (2013) by the
## Broad Institute/Massachusetts Institute of Technology. All rights are
## reserved.
##
## This software is supplied without any warranty or guaranteed support
## whatsoever. Neither the Broad Institute nor MIT can be responsible for its
## use, misuse, or functionality.

#performs PMAD, ZMAD or quantile normalization (method) on shRNA score file (gct.file).
#plots a before and after normalization (plotfile) 

args <- commandArgs(trailingOnly=TRUE)

vers <- "3.2"            # R version
libdir <- args[1]
print(paste("libdir: ",libdir))
server.dir <- args[2]
print(paste("server.dir: ",server.dir))
patch.dir <- args[3]
print(paste("patch.dir: ",patch.dir))

#source(file.path(libdir, "loadRLibrary.R"))
#load.packages(libdir, patch.dir, server.dir, vers)
sessionInfo()
library(getopt)
library(optparse)



option_list <- list(
make_option("--RSfile", dest="RSfile"),
make_option("--PDfile", dest="PDfile"),
make_option("--CCLEfile", dest="CCLEfile"),
make_option("--plateName", dest = "plateName")
 )


opt <- parse_args(OptionParser(option_list=option_list), positional_arguments=TRUE, args=args)
print(opt)
opts <- opt$options

source(file.path(libdir, "FPPassFail.R"))
source(file.path(libdir, "AchillesTeam_common.R"))
source(file.path(libdir, "FPPassFail_helpers.R"))
	sessionInfo()
	
CCLEnamesFile <- paste(libdir,"CCLElineNames.csv", sep = "/")	
FPPassFail(RSfile = opts$RSfile, PDfile = opts$PDfile, CCLEfile = opts$CCLEfile, CCLEnamesFile = CCLEnamesFile, plateName = opts$plateName)

  
 